' Indigo Moon 
'
'   Title: Indigo Moon
'    Date: February 23rd, 1999
'  Author: Jason Jones (Tek)
'          neozones@geocities.com
'          http://www.geocities.com/~neozones/
'
'  Welcome to x-release of Indigo Moon. This QBasic RPG is far from
'  anywhere close to done, but it does have many things in place, and many
'  things planned.
'                     
'  Unfortunately, engine specs that I learned about during the writing of the
'  game have led me to dump this project for a new one, with a more advanced
'  engine architecture.
'
'  Please refer to moonotes.txt for more info about possible problems and
'  release notes.
'
'

DEFINT A-Z
'$DYNAMIC
'$INCLUDE: 'data\resource\directqb.bi'
DECLARE SUB BaseGUISelItem ()
DECLARE SUB BlitScreen ()
DECLARE SUB Box (x1, y1, x2, y2)
DECLARE SUB CastSpellAcquire (Char, Index)
DECLARE SUB CastSpellFinite (TargetType, TargetRef, FromType, FromRef, SpellIndex)
DECLARE SUB ChangeFacingTile (NewTile, Identity)
DECLARE SUB DebugMenu ()
DECLARE SUB DecideItem (Index)
DECLARE SUB DecideTile ()
DECLARE SUB DialogEngine (ForceIndice)
DECLARE SUB GetPlayerSelItem (Position)
DECLARE SUB InitGraphics ()
DECLARE SUB InitStuff ()
DECLARE SUB InitPlayerVars ()
DECLARE SUB InitVars ()
DECLARE SUB Intro ()
DECLARE SUB IntroAbout ()
DECLARE SUB LoadFont (FontName$)
DECLARE SUB LoadMap (AutoAdjust)
DECLARE SUB LoadMapAdj ()
DECLARE SUB LoadMapSet ()
DECLARE SUB LoadTiles ()
DECLARE SUB MapMessage (Message$)
DECLARE SUB MenuEquip ()
DECLARE SUB MenuItems ()
DECLARE SUB MenuMagic ()
DECLARE SUB MenuStats (Default)
DECLARE SUB MoveDown ()
DECLARE SUB MoveLeft ()
DECLARE SUB MoveRight ()
DECLARE SUB MoveUp ()
DECLARE SUB MsgBox (x, y, Text$)
DECLARE SUB PlayGame ()
DECLARE SUB PutPlayerPic ()
DECLARE SUB PutText (Text$, Colour, XPos, YPos)
DECLARE SUB PutTextDropShadow (Text$, Colour, XPos, YPos, DROPCOLOUR)
DECLARE SUB PutTextWrap (Text$, Colour, x1, y1, x2, y2)
DECLARE SUB SaveGameDialog ()
DECLARE SUB Show (Index)
DECLARE SUB ShowMap ()
DECLARE SUB ShowMenu (Index, Reference)
DECLARE SUB ShutDown ()
DECLARE SUB TryAction ()
DECLARE SUB WaitKey ()
DECLARE FUNCTION BaseGUI ()
DECLARE FUNCTION CheckFacingTile (Identity)
DECLARE FUNCTION CheckTile (Identity)
DECLARE FUNCTION Fixed$ (Number)
DECLARE FUNCTION FixedStr$ (Strin$)
DECLARE FUNCTION GetInput$ (Column, Row, MaxLength)
DECLARE FUNCTION GetInputBox$ (Column, Row, MaxLength, Caption$)
DECLARE FUNCTION GetKey$ ()
DECLARE FUNCTION GetPlayer (Default)
DECLARE FUNCTION GetToken$ (Text$, Index)
DECLARE FUNCTION LoadDecideMap ()
DECLARE FUNCTION LoadPal$ (FileName$)
DECLARE FUNCTION RandNum (High, Low)
DECLARE FUNCTION SavedGameLoad ()
DECLARE FUNCTION TileName$ (Number)
DECLARE FUNCTION YesNoBox (x1, y1, Text$)

TYPE WorldDataType
 Rows           AS INTEGER
 Cols           AS INTEGER
 TopRow         AS INTEGER
 TopCol         AS INTEGER
 ColAdj         AS INTEGER
 RowAdj         AS INTEGER
 AnimCycle      AS INTEGER
 Direc          AS INTEGER
 PlayerY        AS INTEGER
 CurItem        AS INTEGER
 MenuItem       AS INTEGER
 MenuOffset     AS INTEGER
 CurOffset      AS INTEGER
 HighItem       AS INTEGER
 Tals           AS INTEGER
 InBattle       AS INTEGER
 SetCol         AS INTEGER
 SetRow         AS INTEGER
 CurMap         AS STRING * 8
 CurSet         AS STRING * 8
END TYPE

TYPE PlayerType
 InParty        AS INTEGER
 Hp             AS INTEGER
 MaxHp          AS INTEGER
 Experience     AS INTEGER
 Attack         AS INTEGER
 Stance         AS INTEGER
 Mp             AS INTEGER
 MaxMp          AS INTEGER
 MagicLevel     AS INTEGER
 Wisdom         AS INTEGER
 Level          AS INTEGER
 ArmorDam       AS INTEGER
 WeaponDam      AS INTEGER
 CharName       AS STRING * 8
 WeaponName     AS STRING * 8
 ArmorName      AS STRING * 8
END TYPE

TYPE SpellsType
 CastPoints     AS INTEGER
 RefName        AS STRING * 20
END TYPE

TYPE ItemsType
 Quantity       AS INTEGER
 Item           AS STRING * 20
END TYPE

TYPE MapType
 Tile           AS INTEGER
 Over           AS INTEGER
 Cons           AS INTEGER
END TYPE

TYPE MapSetType
 FileName       AS STRING * 8
END TYPE

CONST TRUE = -1
CONST FALSE = NOT TRUE
CONST NORTH = 1
CONST EAST = 2
CONST SOUTH = 3
CONST WEST = 4
CONST NUMTILESWALKON = 18
CONST NUMTILESWALKOFF = -14
CONST NUMOVERSWALKOFF = -3
CONST NUMOVERSWALKON = 8
CONST BOXBG = 54
CONST BOXCOL = 28
CONST DROPCOLOUR = BOXBG - 2
CONST HIGHCOLOUR = 142
CONST MAXITEMS = 20
CONST MAXSPELLS = 20
CONST MAXDMATRIX = 2000
CONST PROPTILE = 1
CONST PROPOVER = 2
CONST PROPCONS = 3
CONST PROPENEMY = 1
CONST PROPCOMRADE = 2

DIM SHARED Tiles(201, NUMTILESWALKOFF TO NUMTILESWALKON)
DIM SHARED Overs(201, NUMOVERSWALKOFF TO NUMOVERSWALKON)
DIM SHARED SpriteFace(801, 1 TO 3)
DIM SHARED Sprite(201, 1 TO 8)
DIM SHARED Map(61, 61) AS MapType
DIM SHARED MapSet(1 TO 5, 1 TO 5) AS MapSetType
DIM SHARED DMatrix(1 TO MAXDMATRIX)
DIM SHARED WorldData AS WorldDataType
DIM SHARED Player(1 TO 3)  AS PlayerType
DIM SHARED Items(1 TO MAXITEMS)  AS ItemsType
DIM SHARED Spells(1 TO 3, 1 TO MAXSPELLS) AS SpellsType
DIM SHARED TilesVarseg, OversVarseg
DIM SHARED Font AS STRING * 2305
DIM SHARED Header AS STRING * 64
DIM SHARED Pal AS STRING * 768

CALL InitStuff
CALL Intro
CALL PlayGame

REM $STATIC
FUNCTION BaseGUI

DIM Action

CALL Show(1)
CALL BlitScreen

DO
 SELECT CASE GetKey$
  CASE CHR$(0) + "H"
   WorldData.CurItem = WorldData.CurItem - 1
   IF WorldData.CurItem = 0 THEN WorldData.CurItem = 6
   Action = TRUE
  CASE CHR$(0) + "P"
   WorldData.CurItem = WorldData.CurItem + 1
   IF WorldData.CurItem = 7 THEN WorldData.CurItem = 1
   Action = TRUE
  CASE CHR$(0) + "M"
   WorldData.CurItem = WorldData.CurItem + 3
   IF WorldData.CurItem > 6 THEN WorldData.CurItem = WorldData.CurItem - 6
   Action = TRUE
  CASE CHR$(0) + "K"
   WorldData.CurItem = WorldData.CurItem - 3
   IF WorldData.CurItem < 1 THEN WorldData.CurItem = WorldData.CurItem + 6
   Action = TRUE
  CASE CHR$(13)
   SELECT CASE WorldData.CurItem
    CASE 1
     CALL TryAction
    CASE 2
     CALL MenuEquip
    CASE 3
     CALL MenuItems
    CASE 4
     CALL MenuStats(1)
    CASE 5
     CALL MenuMagic
    CASE 6
     IF YesNoBox(-1, -1, "Really quit?") THEN
      CALL DQBClearLayer(VIDEO)
      CALL Intro
      EXIT FUNCTION
     END IF
   END SELECT
   CALL ShowMap
   BaseGUI = TRUE
   EXIT FUNCTION
  CASE CHR$(27)
   CALL PutPlayerPic
   CALL ShowMap
   CALL BlitScreen
   BaseGUI = FALSE
   EXIT FUNCTION
 END SELECT

 IF Action THEN
  CALL BaseGUISelItem
  CALL BlitScreen
  Action = FALSE
 END IF
LOOP

END FUNCTION

SUB BaseGUISelItem

FOR i = 1 TO 3
 CALL PutTextDropShadow("", BOXBG, 9, i * 10 + 2, BOXBG)
 CALL PutTextDropShadow("", BOXBG, 64, i * 10 + 2, BOXBG)
NEXT i

IF WorldData.CurItem < 4 THEN
 CALL PutTextDropShadow("", 31, 9, WorldData.CurItem * 10 + 2, DROPCOLOUR)
ELSEIF WorldData.CurItem > 3 THEN
 CALL PutTextDropShadow("", 31, 64, (WorldData.CurItem - 3) * 10 + 2, DROPCOLOUR)
END IF

END SUB

SUB BlitScreen

CALL DQBcopyLayer(1, VIDEO)

END SUB

SUB Box (x1, y1, x2, y2)

CALL DQBBox(1, x1, y1, x2, y2, BOXCOL - 2)
CALL DQBBox(1, x1 + 1, y1 + 1, x2 - 1, y2 - 1, BOXCOL)
CALL DQBBox(1, x1 + 2, y1 + 2, x2 - 2, y2 - 2, BOXCOL - 4)
CALL DQBBoxf(1, x1 + 3, y1 + 3, x2 - 3, y2 - 3, BOXBG)

END SUB

SUB CastSpellAcquire (Char, Index)

IF WorldData.InBattle = FALSE THEN
 CALL MapMessage("Who to cast '" + FixedStr$(Spells(Char, Index).RefName) + "' on?")
 Castee = GetPlayer(1)
 IF Castee THEN
  CALL CastSpellFinite(PROPCOMRADE, Castee, PROPCOMRADE, Char, Index)
 END IF
ELSE
 ' IN-BATTLE
END IF

END SUB

SUB CastSpellFinite (TargetType, TargetRef, FromType, FromRef, SpellIndex)



END SUB

SUB ChangeFacingTile (NewTile, Identity)

DIM ColOffset, RowOffset

SELECT CASE WorldData.Direc
 CASE NORTH
  ColOffset = 0
  RowOffset = -1
 CASE EAST
  ColOffset = 1
  RowOffset = 0
 CASE SOUTH
  ColOffset = 0
  RowOffset = 1
 CASE WEST
  ColOffset = -1
  RowOffset = 0
END SELECT

SELECT CASE Identity
 CASE PROPTILE
  Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Tile = NewTile
 CASE PROPOVER
  Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Over = NewTile
 CASE PROPCONS
  Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Cons = NewTile
END SELECT

END SUB

FUNCTION CheckFacingTile (Identity)

DIM ColOffset, RowOffset

SELECT CASE WorldData.Direc
 CASE NORTH
  ColOffset = 0
  RowOffset = -1
 CASE EAST
  ColOffset = 1
  RowOffset = 0
 CASE SOUTH
  ColOffset = 0
  RowOffset = 1
 CASE WEST
  ColOffset = -1
  RowOffset = 0
END SELECT

SELECT CASE Identity
 CASE PROPTILE
  CheckFacingTile = Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Tile
 CASE PROPOVER
  CheckFacingTile = Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Over
 CASE PROPCONS
  CheckFacingTile = Map(WorldData.TopCol + ColOffset + WorldData.ColAdj + 8, WorldData.TopRow + RowOffset + WorldData.RowAdj + 5).Cons
END SELECT

END FUNCTION

FUNCTION CheckTile (Identity)

SELECT CASE Identity
 CASE PROPTILE
  CheckTile = Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Tile
 CASE PROPOVER
  CheckTile = Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Over
 CASE PROPCONS
  CheckTile = Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Cons
END SELECT

END FUNCTION

SUB DebugMenu

SELECT CASE LCASE$(GetInputBox$(-1, -1, 33, "Im:\>"))
 CASE "set"
  FOR i = 1 TO 5
   FOR j = 1 TO 5
    CALL PutText(MapSet(i, j).FileName, 0, 31, c * 8)
    c = c + 1
   NEXT j
  NEXT i
  CALL BlitScreen
  CALL WaitKey
 CASE "stats"
  CALL Box(10, 10, 309, 80)
  CALL PutTextDropShadow("Statistics:", 31, 16, 16, 0)
  CALL PutTextDropShadow(" Position:               Tiles:", 31, 16, 32, 0)
  CALL PutText("  Col: " + Fixed$(WorldData.TopCol + 8) + "  Row: " + Fixed$(WorldData.TopRow + 5), 31, 16, 40)
  CALL PutText("  RCo: " + Fixed$(WorldData.TopCol) + "  RRo: " + Fixed$(WorldData.TopRow), 31, 16, 48)
  CALL PutText("  AdC: " + Fixed$(WorldData.ColAdj) + "  AdR: " + Fixed$(WorldData.RowAdj), 31, 16, 56)
  CALL PutText("  Til: " + Fixed$(Map(WorldData.TopCol + 8, WorldData.TopRow + 5).Tile), 31, 160, 40)
  CALL PutText(" FTil: " + Fixed$(CheckFacingTile(PROPTILE)), 31, 160, 48)
  CALL PutText(" Dmatrix(1) = " + Fixed$(DMatrix(1)), 31, 160, 56)
  CALL BlitScreen
  CALL WaitKey
END SELECT

END SUB

SUB DecideItem (Index)

PlayerToUseOn = GetPlayer(1)

Items(Index).Quantity = Items(Index).Quantity - 1

IF Items(Index).Quantity <= 0 THEN
 Items(Index).Item = ""
 Items(Index).Quantity = 0
END IF

CALL ShowMap
'CALL PutTextDropShadow("Item was used on " + FixedStr(Player(PlayerToUseOn).CharName) + ".", 31, -1, 96, 16)

CALL BlitScreen

CALL WaitKey

'SELECT CASE Items(Index).Item           ' id?

'END SELECT

END SUB

SUB DecideTile

DIM Adj

'CALL LoadDecideMap

IF CheckTile(PROPCONS) THEN
 IF CheckTile(PROPOVER) = 3 THEN
  IF WorldData.Direc = NORTH THEN
   CALL MoveDown
   WorldData.Direc = NORTH
  ELSE
   CALL MoveUp
   WorldData.Direc = SOUTH
  END IF
  CALL ChangeFacingTile(2, PROPOVER)
 ELSE
  NewMap$ = "data\cons\" + Fixed$(CheckTile(PROPCONS)) + ".igr"
  IF LEN(DQBdir$(NewMap$, ATTRIB.A)) THEN
   OPEN NewMap$ FOR BINARY AS #1
   GET #1, , WorldData.CurMap
   GET #1, , WorldData.TopCol
   GET #1, , WorldData.TopRow
   CLOSE #1
   WorldData.TopCol = WorldData.TopCol - 8
   WorldData.TopRow = WorldData.TopRow - 5
   WorldData.ColAdj = 0
   WorldData.RowAdj = 0
   CALL LoadMap(TRUE)
  END IF
 END IF
END IF

END SUB

SUB DialogEngine (ForceIndice)

DIM Indice, Record$

IF ForceIndice THEN Indice = ForceIndice ELSE Indice = CheckFacingTile(PROPCONS)

IF LEN(DQBdir$("data\dialog\" + Fixed$(Indice) + ".idt", ATTRIB.A)) THEN
 OPEN "data\dialog\" + Fixed$(Indice) + ".idt" FOR INPUT AS #1
 DO
  LINE INPUT #1, Record$
  IF GetToken$(Record$, 1) = "/record" AND VAL(GetToken$(Record$, 2)) = DMatrix(Indice) THEN
   DO UNTIL FixedStr$(Record$) = "/done"
    LINE INPUT #1, Record$
    SELECT CASE FixedStr$(GetToken(Record$, 1))
     CASE "/out"
      CALL PutTextWrap(RIGHT$(Record$, LEN(Record$) - 5), 31, 2, 144, 317, 197)
     CASE "/setd"
      DMatrix(VAL(GetToken$(Record$, 2))) = VAL(GetToken$(Record$, 3))
    END SELECT
   LOOP
   EXIT DO
  END IF
 LOOP WHILE NOT (EOF(1))
END IF

CLOSE #1

END SUB

FUNCTION Fixed$ (Number)

Fixed$ = (LTRIM$(RTRIM$(STR$(Number))))

END FUNCTION

FUNCTION FixedStr$ (Strin$)

FixedStr$ = LTRIM$(RTRIM$(Strin$))

END FUNCTION

FUNCTION GetInput$ (Column, Row, MaxLength)

DIM Inpt$, Length, Key$

Inpt$ = ""
Length = 0
Key$ = ""

DO
 Key$ = GetKey$
 IF Key$ <> "" THEN
  SELECT CASE Key$
   CASE CHR$(8)
    IF Length > 0 THEN Length = Length - 1
    Inpt$ = LEFT$(Inpt$, Length)
   CASE CHR$(13), CHR$(27)
    EXIT DO
   CASE ELSE
    IF ASC(Key$) > 31 AND ASC(Key$) < 128 THEN
     IF Length < MaxLength THEN
      Inpt$ = Inpt$ + Key$
      Length = Length + 1
     END IF
    END IF
  END SELECT
 
  CALL DQBBoxf(1, Column, Row, Column + DQBlen(Inpt$) + 8, Row + 8, BOXBG)
  CALL PutText(Inpt$, 31, Column, Row)
  CALL BlitScreen

 END IF

LOOP

GetInput$ = Inpt$

END FUNCTION

FUNCTION GetInputBox$ (Column, Row, MaxLength, Caption$)

IF Column = -1 THEN
 Column = 160 - (((MaxLength * 6) + 16) / 2)
END IF
IF Row = -1 THEN
 Row = 87
END IF

CALL Box(Column, Row, (MaxLength * 6) + 16 + Column, Row + 26)
CALL PutText(Caption$, 31, Column + 5, Row + 5)

CALL BlitScreen

GetInputBox$ = GetInput$(Column + 5, Row + 13, MaxLength)

END FUNCTION

FUNCTION GetKey$

kbd$ = INKEY$
IF kbd$ <> "" THEN GetKey$ = kbd$

END FUNCTION

FUNCTION GetPlayer (Default)

DIM Action, CurSelection

CALL Show(5)
CALL BlitScreen
Action = TRUE
CurSelection = Default

DO
 SELECT CASE GetKey$
  CASE CHR$(0) + "H"
   CurSelection = CurSelection - 1
   IF CurSelection = 0 THEN CurSelection = 3
   Action = TRUE
  CASE CHR$(0) + "P"
   CurSelection = CurSelection + 1
   IF CurSelection = 4 THEN CurSelection = 1
   Action = TRUE
  CASE CHR$(0) + "M", CHR$(0) + "K"
   Player(CurSelection).Stance = Player(CurSelection).Stance XOR 1
   CALL Show(5)
   Action = TRUE
  CASE CHR$(13)
   GetPlayer = CurSelection
   EXIT FUNCTION
  CASE CHR$(27)
   GetPlayer = FALSE
   EXIT FUNCTION
 END SELECT

 IF Action THEN
  CALL GetPlayerSelItem(CurSelection)
  Action = FALSE
 END IF
LOOP


END FUNCTION

SUB GetPlayerSelItem (Position)

FOR i = 0 TO 2
 CALL PutTextDropShadow("", BOXBG, 122, i * 50 + 7, BOXBG)
NEXT i

CALL PutTextDropShadow("", 31, 122, (Position - 1) * 50 + 7, DROPCOLOUR)

CALL BlitScreen

END SUB

FUNCTION GetToken$ (Text$, Index)

Text$ = " " + LTRIM$(RTRIM$(Text$)) + " "

FOR i = 1 TO LEN(Text$) - 1
 IF MID$(Text$, i, 1) = " " THEN
  Index = Index - 1
  IF Index = 0 THEN
   GetToken$ = LTRIM$(RTRIM$(MID$(Text$, i, INSTR(RIGHT$(Text$, LEN(Text$) - i), " "))))
   EXIT FUNCTION
  END IF
 END IF
NEXT i

END FUNCTION

SUB InitGraphics

Result = DQBinit(1, 0)

IF Result THEN
 PRINT
 PRINT
 PRINT "Error initializing graphics routines (" + Fixed$(Result) + "), aborting."
 PRINT
 PRINT
 CALL ShutDown
END IF

END SUB

SUB InitPlayerVars

FOR i = 1 TO 3
 Player(i).InParty = TRUE
 Player(i).Hp = 30
 Player(i).MaxHp = 30
 Player(i).Level = 1
 Player(i).Experience = 0
 Player(i).Attack = 1
 Player(i).Stance = ABS((i AND 1) - 1)
 Player(i).Mp = 0
 Player(i).MaxMp = 4
 Player(i).MagicLevel = 0
 Player(i).Wisdom = 1
 Player(i).WeaponDam = 4
 Player(i).ArmorDam = 3
 Player(i).ArmorName = "Clothes"
NEXT i

Player(1).CharName = "Caliban"
Player(2).CharName = "Rachelle"
Player(3).CharName = "Milo"
Player(1).WeaponName = "Sword"
Player(2).WeaponName = "Spear"
Player(3).WeaponName = "Axe"

WorldData.Tals = 215

Items(1).Item = "Lutaberry"
Items(1).Quantity = 3
Items(2).Item = "Firewater"
Items(2).Quantity = 1
Items(9).Item = "Bottle"
Items(9).Quantity = 2

Items(11).Item = "Broken Glass"
Items(11).Quantity = 3
Items(13).Item = "Barrel"
Items(13).Quantity = 1
Items(20).Item = "Paintball Gun"
Items(20).Quantity = 2

WorldData.TopCol = 23
WorldData.TopRow = 30
WorldData.PlayerY = 96
WorldData.AnimCycle = 0
WorldData.Direc = SOUTH
WorldData.ColAdj = 0
WorldData.RowAdj = 0
WorldData.InBattle = FALSE
WorldData.SetCol = 3
WorldData.SetRow = 1
WorldData.CurSet = "main"

CALL LoadMapSet

WorldData.CurMap = MapSet(WorldData.SetRow, WorldData.SetCol).FileName

FOR i = 1 TO UBOUND(DMatrix)
 DMatrix(i) = 1
NEXT i

FOR i = 1 TO 3
 FOR j = 1 TO MAXSPELLS
  Spells(i, j).RefName = ""
  Spells(i, j).CastPoints = 0
 NEXT j
NEXT i

Spells(1, 1).RefName = "Prescience"
Spells(1, 1).CastPoints = 3
Spells(2, 1).RefName = "Heal"
Spells(2, 1).CastPoints = 2
Spells(3, 1).RefName = "Enhance"
Spells(3, 1).CastPoints = 1

END SUB

SUB InitStuff

SCREEN 0: WIDTH 80, 25: CLS : LOCATE , , 1

COLOR 15, 1
PRINT "  Initializing Indigo Moon                                Indigo Entertainment  "
COLOR 7, 0
PRINT
PRINT "This is x-release #1 of Indigo Moon. Not to be released to the public domain."
PRINT
PRINT "Welcome to Indigo Moon, a land of enchantment, wonder, and beauty, paling only"
PRINT "in comparison to the human mind."
PRINT
PRINT "Initializing local variables..."; : CALL InitVars: PRINT "done."
PRINT "Initializing graphics routines..."; : CALL InitGraphics: PRINT "done."
PRINT "Loading images... ("; Fixed$(ABS(NUMTILESWALKOFF) + NUMTILESWALKON + 1); "+" + Fixed$(ABS(NUMOVERSWALKOFF) + NUMOVERSWALKON + 1); " tiles) "; : CALL LoadTiles: PRINT "done."
PRINT "Loading font..."; : CALL LoadFont("8xpoly"): PRINT "done."
PRINT
PRINT "The time is "; TIME$; ", ("; DATE$; ")."
PRINT
PRINT "Free array space:"; FRE(-1); "bytes."
PRINT "Available stack:"; FRE(-2); "bytes."
PRINT "Largest free string block:"; FRE(""); "bytes."
PRINT "Current EMS segment: "; Fixed$(DQBemsSeg); "."
PRINT
PRINT "Now ready to launch Indigo Moon, press a key...";

CALL WaitKey

SCREEN 13

END SUB

SUB InitVars

RANDOMIZE TIMER

WorldData.CurItem = 1
WorldData.MenuItem = 1
WorldData.MenuOffset = 0
WorldData.CurOffset = 0
WorldData.HighItem = 0

END SUB

SUB Intro

DIM Options$(1 TO 5), Action, CurSelection

Options$(1) = "Begin"
Options$(2) = "Saved"
Options$(3) = "Options"
Options$(4) = "About"
Options$(5) = "Quit"
Action = TRUE
CurSelection = 1

CALL Show(7)
CALL BlitScreen

DO
 SELECT CASE GetKey$
  CASE CHR$(0) + "H"
   CurSelection = CurSelection - 1
   IF CurSelection = 0 THEN CurSelection = 5
   Action = TRUE
  CASE CHR$(0) + "P"
   CurSelection = CurSelection + 1
   IF CurSelection = 6 THEN CurSelection = 1
   Action = TRUE
  CASE CHR$(13)
   SELECT CASE CurSelection
    CASE 1
     WorldData.CurSet = "main"
     CALL InitPlayerVars
     CALL LoadMap(TRUE)
     EXIT DO
    CASE 2
     Result = SavedGameLoad
     IF Result THEN
      EXIT DO
     ELSE
      CALL Show(7)
      CALL BlitScreen
      Action = TRUE
     END IF
    CASE 4
     CALL IntroAbout
     CALL Show(7)
     CALL BlitScreen
     Action = TRUE
    CASE 5
     CALL ShutDown
   END SELECT
 END SELECT

 IF Action THEN
  CALL DQBClearLayer(1)
  FOR i = 1 TO 5
   IF CurSelection <> i THEN
    CALL PutText(Options$(i), 2, -1, i * 10 + 130)
   ELSE
    CALL PutText(Options$(i), 61, -1, i * 10 + 130)
   END IF
  NEXT i
  Action = FALSE
  CALL DQBcopyTransLayer(1, VIDEO)
 END IF
LOOP

CALL DQBClearLayer(0)
CALL DQBClearLayer(1)
CALL DQBsetPal(LoadPal$("nmedia"))
TilesVarseg = VARSEG(Tiles(0, 0))
OversVarseg = VARSEG(Overs(0, 0))
CALL ShowMap
CALL BlitScreen

END SUB

SUB IntroAbout

DIM Bottom

CALL Show(7)
CALL BlitScreen

CALL DQBsetClipBox(95, 108, 224, 190)

OPEN "data\ido\credits.ido" FOR INPUT AS #1

DO
 INPUT #1, Colour, Text$
 IF Colour = 3 THEN
  Bottom = 144
 ELSE
  Bottom = 100
 END IF
 FOR i = 190 TO Bottom STEP -1
  CALL DQBBoxf(VIDEO, 95, 108, 224, 190, 0)
  CALL DQBPrint(VIDEO, Text$, 160 - DQBlen(Text$) / 2, i, Colour)
  IF GetKey$ <> "" THEN
   CALL DQBsetClipBox(0, 0, 319, 199)
   CLOSE #1
   EXIT SUB
  END IF
  CALL DQBWait(1)
 NEXT i
LOOP WHILE Colour <> 3

CALL WaitKey

CLOSE #1

CALL DQBsetClipBox(0, 0, 319, 199)

END SUB

FUNCTION LoadDecideMap

DIM Action

IF WorldData.Direc = WEST AND WorldData.ColAdj = -8 AND WorldData.SetCol > 1 THEN
 IF LEN(FixedStr$(MapSet(WorldData.SetRow, WorldData.SetCol - 1).FileName)) THEN
  WorldData.SetCol = WorldData.SetCol - 1
  WorldData.TopCol = 45
  WorldData.ColAdj = 7
  Action = TRUE
 END IF
ELSEIF WorldData.Direc = EAST AND WorldData.ColAdj = 7 AND WorldData.SetCol < 5 THEN
 IF LEN(FixedStr$(MapSet(WorldData.SetRow, WorldData.SetCol + 1).FileName)) THEN
  WorldData.SetCol = WorldData.SetCol + 1
  WorldData.TopCol = 1
  WorldData.ColAdj = -8
  Action = TRUE
 END IF
ELSEIF WorldData.Direc = SOUTH AND WorldData.RowAdj = 4 AND WorldData.SetRow < 5 THEN
 IF LEN(FixedStr$(MapSet(WorldData.SetRow + 1, WorldData.SetCol).FileName)) THEN
  WorldData.SetRow = WorldData.SetRow + 1
  WorldData.TopRow = 1
  WorldData.RowAdj = -5
  Action = TRUE
 END IF
ELSEIF WorldData.Direc = NORTH AND WorldData.RowAdj = -5 AND WorldData.SetRow > 1 THEN
 IF LEN(FixedStr$(MapSet(WorldData.SetRow - 1, WorldData.SetCol).FileName)) THEN
  WorldData.SetRow = WorldData.SetRow - 1
  WorldData.TopRow = 51
  WorldData.RowAdj = 4
  Action = TRUE
 END IF
END IF

IF Action THEN
 WorldData.CurMap = MapSet(WorldData.SetRow, WorldData.SetCol).FileName
 CALL LoadMap(FALSE)
 LoadDecideMap = TRUE
END IF

END FUNCTION

SUB LoadFont (FontName$)

OPEN "data\fonts\" + FontName$ + ".fnt" FOR BINARY AS #1

GET #1, , Font

CLOSE #1

CALL DQBsetFont(Font)

END SUB

SUB LoadMap (AutoAdjust)

OPEN "maps\" + FixedStr$(WorldData.CurMap) + ".imm" FOR BINARY AS #1

GET #1, , Header
GET #1, , WorldData.Rows
GET #1, , WorldData.Cols

FOR i = 1 TO WorldData.Rows
 FOR j = 1 TO WorldData.Cols
  GET #1, , Map(j, i)
 NEXT j
NEXT i

CLOSE #1

IF AutoAdjust THEN CALL LoadMapAdj

END SUB

SUB LoadMapAdj

IF WorldData.TopCol < 2 THEN
 WorldData.ColAdj = WorldData.TopCol - 1
 WorldData.TopCol = 1
END IF

IF WorldData.TopCol > 45 THEN
 WorldData.ColAdj = 59 - WorldData.TopCol
 WorldData.TopCol = 45
END IF

IF WorldData.TopRow < 2 THEN
 WorldData.RowAdj = WorldData.TopRow - 1
 WorldData.TopRow = 1
END IF

IF WorldData.TopRow > 51 THEN
 WorldData.RowAdj = 59 - WorldData.TopRow
 WorldData.TopRow = 51
END IF

END SUB

SUB LoadMapSet

FileName$ = "maps\sets\" + FixedStr$(WorldData.CurSet) + ".set"

FOR i = 1 TO 5
 FOR j = 1 TO 5
  MapSet(i, j).FileName = ""
 NEXT j
NEXT i

IF LEN(DQBdir$(FileName$, ATTRIB.A)) THEN
 OPEN FileName$ FOR INPUT AS #1
 FOR i = 1 TO 5
  FOR j = 1 TO 5
   LINE INPUT #1, MapSet(i, j).FileName
   IF EOF(1) THEN
    CLOSE #1
    EXIT SUB
   END IF
  NEXT j
 NEXT i
 CLOSE #1
END IF


END SUB

FUNCTION LoadPal$ (FileName$)

OPEN "images\palettes\" + FileName$ + ".pal" FOR BINARY AS #1

GET #1, 1, Pal

CLOSE #1

LoadPal$ = Pal

END FUNCTION

SUB LoadTiles

FOR i = NUMTILESWALKOFF TO NUMTILESWALKON
 DEF SEG = VARSEG(Tiles(0, i)): BLOAD "images\tiles\" + TileName$(i) + ".mdt", VARPTR(Tiles(0, i))
NEXT i

FOR i = NUMOVERSWALKOFF TO NUMOVERSWALKON
 DEF SEG = VARSEG(Overs(0, i))
 BLOAD "images\overs\" + TileName$(i) + ".mdt", VARPTR(Overs(0, i))
NEXT i

FOR i = 1 TO 3
 DEF SEG = VARSEG(SpriteFace(0, i)): BLOAD "images\sprites\faces\f00" + Fixed$(i) + ".mdt", VARPTR(SpriteFace(0, i))
NEXT i

FOR i = 1 TO 8
 DEF SEG = VARSEG(Sprite(0, i)): BLOAD "images\sprites\chars\" + TileName$(i) + ".mdt", VARPTR(Sprite(0, i))
NEXT i

END SUB

SUB MapMessage (Message$)

CALL PutTextDropShadow(Message$, 31, 6, 188, 16)

END SUB

SUB MenuEquip

CALL Show(3)

DO
 SELECT CASE GetKey$
  CASE CHR$(27)
   EXIT SUB
 END SELECT
LOOP

END SUB

SUB MenuItems

WorldData.MenuItem = 1
WorldData.MenuOffset = 0
WorldData.CurOffset = 1
WorldData.HighItem = 0

CALL Show(2)

DO
 SELECT CASE GetKey$
  CASE CHR$(0) + "H"
   IF WorldData.MenuItem > 1 THEN
    WorldData.MenuItem = WorldData.MenuItem - 1
    WorldData.CurOffset = WorldData.CurOffset - 1
    IF WorldData.CurOffset = 0 THEN
     WorldData.CurOffset = 1
     WorldData.MenuOffset = WorldData.MenuOffset - 1
    END IF
   END IF
   IF WorldData.MenuOffset < 0 THEN WorldData.MenuOffset = 0
   CALL Show(2)
  CASE CHR$(0) + "P"
   IF WorldData.MenuItem < MAXITEMS THEN
    WorldData.MenuItem = WorldData.MenuItem + 1
    WorldData.CurOffset = WorldData.CurOffset + 1
    IF WorldData.CurOffset = 10 THEN
     WorldData.MenuOffset = WorldData.MenuOffset + 1
     WorldData.CurOffset = 9
    END IF
   END IF
   IF WorldData.MenuOffset > MAXITEMS - 9 THEN WorldData.MenuOffset = MAXITEMS - 9
   CALL Show(2)
  CASE CHR$(13)
   IF WorldData.HighItem THEN
    IF WorldData.MenuOffset + WorldData.CurOffset = WorldData.HighItem THEN
     IF Items(WorldData.MenuItem).Quantity THEN
      IF YesNoBox(113, 123, "Use Item?") THEN
       CALL DecideItem(WorldData.HighItem)
       WorldData.HighItem = 0
      ELSE
       WorldData.HighItem = FALSE
      END IF
      CALL ShowMap
      CALL Show(1)
      CALL Show(2)
     END IF
   
    ELSE
     SWAP Items(WorldData.HighItem), Items(WorldData.MenuOffset + WorldData.CurOffset)
     WorldData.HighItem = FALSE
    END IF
   ELSE
    IF Items(WorldData.MenuOffset + WorldData.CurOffset).Quantity THEN
     WorldData.HighItem = WorldData.MenuOffset + WorldData.CurOffset
    END IF
   END IF
  
   CALL Show(2)
   
  CASE CHR$(27)
   EXIT SUB

 END SELECT
LOOP

END SUB

SUB MenuMagic

Player = GetPlayer(1)

IF Player = 0 THEN EXIT SUB

WorldData.MenuItem = 1
WorldData.MenuOffset = 0
WorldData.CurOffset = 1
'WorldData.HighItem = 0

CALL ShowMenu(2, Player)

DO
 SELECT CASE GetKey$
  CASE CHR$(0) + "H"
   IF WorldData.MenuItem > 1 THEN
    WorldData.MenuItem = WorldData.MenuItem - 1
    WorldData.CurOffset = WorldData.CurOffset - 1
    IF WorldData.CurOffset = 0 THEN
     WorldData.CurOffset = 1
     WorldData.MenuOffset = WorldData.MenuOffset - 1
    END IF
   END IF
   IF WorldData.MenuOffset < 0 THEN WorldData.MenuOffset = 0
   CALL ShowMenu(2, Player)
  CASE CHR$(0) + "P"
   IF WorldData.MenuItem < MAXITEMS THEN
    WorldData.MenuItem = WorldData.MenuItem + 1
    WorldData.CurOffset = WorldData.CurOffset + 1
    IF WorldData.CurOffset = 10 THEN
     WorldData.MenuOffset = WorldData.MenuOffset + 1
     WorldData.CurOffset = 9
    END IF
   END IF
   IF WorldData.MenuOffset > MAXITEMS - 9 THEN WorldData.MenuOffset = MAXITEMS - 9
   CALL ShowMenu(2, Player)
  CASE CHR$(13)
   CALL CastSpellAcquire(Player, WorldData.MenuOffset + WorldData.CurOffset)
   EXIT SUB
  CASE CHR$(27)
   EXIT SUB
 END SELECT
LOOP


END SUB

SUB MenuStats (Default)

DO

 Player = GetPlayer(Default)

 IF Player THEN
  CALL Show(6)
  CALL ShowMenu(1, Player)
  CALL BlitScreen
  DO
   SELECT CASE GetKey$
    CASE CHR$(27)
     CALL ShowMap
     CALL Show(1)
     Default = Player
     EXIT DO
   END SELECT
  LOOP
 ELSE
  EXIT DO
 END IF
LOOP

END SUB

SUB MoveDown

WorldData.Direc = SOUTH

IF LoadDecideMap THEN EXIT SUB

IF Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 6 + WorldData.RowAdj).Tile > 0 THEN
 IF Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 6 + WorldData.RowAdj).Over >= 0 THEN
  IF WorldData.RowAdj < 0 THEN
   WorldData.RowAdj = WorldData.RowAdj + 1
  ELSEIF WorldData.RowAdj >= 0 THEN
   WorldData.TopRow = WorldData.TopRow + 1
  END IF
  
  IF WorldData.TopRow > 51 THEN
   WorldData.RowAdj = WorldData.RowAdj + 1
   WorldData.TopRow = WorldData.TopRow - 1
  END IF
 END IF
END IF

END SUB

SUB MoveLeft

WorldData.Direc = WEST

IF LoadDecideMap THEN EXIT SUB

IF Map(WorldData.TopCol + 7 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Tile > 0 THEN
 IF Map(WorldData.TopCol + 7 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Over >= 0 THEN
  IF WorldData.ColAdj > 0 THEN
   WorldData.ColAdj = WorldData.ColAdj - 1
  ELSEIF WorldData.ColAdj <= 0 THEN
   WorldData.TopCol = WorldData.TopCol - 1
  END IF
  IF WorldData.TopCol < 1 THEN
   WorldData.ColAdj = WorldData.ColAdj - 1
   WorldData.TopCol = WorldData.TopCol + 1
  END IF
 END IF
END IF

END SUB

SUB MoveRight

WorldData.Direc = EAST

IF LoadDecideMap THEN EXIT SUB

IF Map(WorldData.TopCol + 9 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Tile > 0 THEN
 IF Map(WorldData.TopCol + 9 + WorldData.ColAdj, WorldData.TopRow + 5 + WorldData.RowAdj).Over >= 0 THEN
  IF WorldData.ColAdj < 0 THEN
   WorldData.ColAdj = WorldData.ColAdj + 1
  ELSEIF WorldData.ColAdj >= 0 THEN
   WorldData.TopCol = WorldData.TopCol + 1
  END IF

  IF WorldData.TopCol > 45 THEN
   WorldData.ColAdj = WorldData.ColAdj + 1
   WorldData.TopCol = WorldData.TopCol - 1
  END IF
 END IF
END IF

END SUB

SUB MoveUp

WorldData.Direc = NORTH

IF LoadDecideMap THEN EXIT SUB

IF Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 4 + WorldData.RowAdj).Tile > 0 THEN
 IF Map(WorldData.TopCol + 8 + WorldData.ColAdj, WorldData.TopRow + 4 + WorldData.RowAdj).Over >= 0 THEN
  IF WorldData.RowAdj > 0 THEN
   WorldData.RowAdj = WorldData.RowAdj - 1
  ELSEIF WorldData.RowAdj <= 0 THEN
   WorldData.TopRow = WorldData.TopRow - 1
  END IF
 
  IF WorldData.TopRow < 1 THEN
   WorldData.RowAdj = WorldData.RowAdj - 1
   WorldData.TopRow = WorldData.TopRow + 1
  END IF
 END IF
END IF

END SUB

SUB MsgBox (x, y, Text$)

IF FixedStr$(Text$) <> "" THEN
 IF x = -1 THEN
  x = 160 - (DQBlen(Text$) / 2 + 5)
 END IF
 IF y = -1 THEN
  y = 91
 END IF

 CALL Box(x, y, x + DQBlen(Text$) + 10, y + 18)
 CALL PutText(Text$, 31, x + 5, y + 5)
 CALL BlitScreen
 CALL WaitKey

END IF

END SUB

SUB PlayGame

DIM Action

DO
 SELECT CASE GetKey$
  CASE " "
   CALL TryAction
   Action = TRUE
  CASE CHR$(0) + "H"
   CALL MoveUp
   Action = TRUE
  CASE CHR$(0) + "P"
   CALL MoveDown
   Action = TRUE
  CASE CHR$(0) + "K"
   CALL MoveLeft
   Action = TRUE
  CASE CHR$(0) + "M"
   CALL MoveRight
   Action = TRUE
  CASE CHR$(27)
   WorldData.CurItem = 1
   DO
   LOOP WHILE BaseGUI
  CASE CHR$(0) + "B"
   CALL DebugMenu
   Action = TRUE
 END SELECT

 IF Action THEN
  CALL DecideTile
  CALL ShowMap
  CALL BlitScreen
  Action = FALSE
 END IF

LOOP

END SUB

SUB PutPlayerPic

WorldData.AnimCycle = WorldData.AnimCycle XOR 1

CALL DQBput(1, 160 + WorldData.ColAdj * 20, WorldData.PlayerY + WorldData.RowAdj * 20 - WorldData.AnimCycle, VARSEG(Sprite(0, WorldData.Direc * 2 - 1 + WorldData.AnimCycle)), VARPTR(Sprite(0, WorldData.Direc * 2 - 1 + WorldData.AnimCycle)))

END SUB

SUB PutText (Text$, Colour, XPos, YPos)
                   
IF XPos = -1 THEN XPos = 160 - DQBlen(Text$) / 2

CALL DQBPrint(1, Text$, XPos, YPos, Colour)

EXIT SUB

END SUB

SUB PutTextDropShadow (Text$, Colour, XPos, YPos, DROPCOLOUR)

IF XPos = -1 THEN
 CALL PutText(Text$, DROPCOLOUR, 161 - DQBlen(Text$) / 2, YPos + 1)
ELSE
 CALL PutText(Text$, DROPCOLOUR, XPos + 1, YPos + 1)
END IF

CALL PutText(Text$, Colour, XPos, YPos)

END SUB

SUB PutTextWrap (Text$, Colour, x1, y1, x2, y2)

DIM CurRow, CurLine$

CALL Box(x1, y1, x2, y2)

x1 = x1 + 5
x2 = x2 - 5
y1 = y1 + 5
y2 = y2 - 5

MaxLineLength = x2 - x1 - 1

CurRow = 0
CurLine$ = ""

DO
 DO
  IF INSTR(Text$, " ") = 0 THEN EXIT DO
  CurLine$ = CurLine$ + MID$(Text$, 1, INSTR(Text$, " "))
  Text$ = RIGHT$(Text$, LEN(Text$) - INSTR(Text$, " "))
 LOOP UNTIL DQBlen(CurLine$ + MID$(Text$, 1, INSTR(Text$, " "))) > MaxLineLength

 CALL PutText(LTRIM$(CurLine$), Colour, x1, y1 + (CurRow * 8))
 CurRow = CurRow + 1

 IF CurRow > 3 THEN
  CALL PutText("", Colour, x2 - 8, y1 + (CurRow * 8))
  CALL BlitScreen
  CALL WaitKey
  CurRow = 0
  CALL Box(x1 - 5, y1 - 5, x2 + 5, y2 + 5)
 END IF

 CurLine$ = ""

 IF DQBlen(Text$) <= MaxLineLength THEN
  CALL PutText(LTRIM$(Text$), Colour, x1, y1 + (CurRow * 8))
  EXIT DO
 END IF

LOOP

CALL BlitScreen
CALL WaitKey

END SUB

FUNCTION RandNum (High, Low)

RandNum = INT(RND * (High - Low) + Low)

END FUNCTION

FUNCTION SavedGameLoad

DIM CurSelection, Action, Desc$(1 TO 4)

FOR i = 1 TO 4
 Temp$ = DQBdir$("saves\data" + Fixed$(i) + ".sav", ATTRIB.A)
 IF LEN(Temp$) THEN
  OPEN "saves\data" + Fixed$(i) + ".sav" FOR BINARY AS #1
  IF LOF(1) = 0 THEN
   Desc$(i) = "[unused]"
  ELSE
   GET #1, , Header
   Desc$(i) = Header
  END IF
  CLOSE #1
 ELSE
  Desc$(i) = "[unused]"
 END IF
NEXT i

CurSelection = 1
Action = TRUE

DO
 kbd$ = INKEY$
 IF kbd$ <> "" THEN
  SELECT CASE kbd$
   CASE CHR$(0) + "H"
    CurSelection = CurSelection - 1
    IF CurSelection = 0 THEN CurSelection = 5
    Action = TRUE
   CASE CHR$(0) + "P"
    CurSelection = CurSelection + 1
    IF CurSelection = 6 THEN CurSelection = 1
    Action = TRUE
   CASE CHR$(13)
    SELECT CASE CurSelection
     CASE 1 TO 4
      EXIT DO
     CASE 5
      SaveGameLoad = FALSE
      EXIT FUNCTION
    END SELECT
   CASE CHR$(27)
    SavedGameLoad = FALSE
    EXIT FUNCTION
  END SELECT
 END IF
 IF Action THEN
  CALL Show(7)
  CALL PutText("Saved Games:", 61, -1, 104)
  CALL PutText("Back to main", 2, 96, 168)
  FOR i = 1 TO 4
   CALL PutText(Fixed$(i) + ". " + Desc$(i), 2, 96, 112 + i * 8)
  NEXT i
  IF CurSelection < 5 THEN Row = CurSelection ELSE Row = 7
  CALL PutText("", 2, 88, 112 + Row * 8)
  CALL BlitScreen
  Action = FALSE
 END IF
LOOP

OPEN "saves\data" + Fixed$(CurSelection) + ".sav" FOR BINARY AS #1

IF LOF(1) = 0 THEN
 SavedGameLoad = FALSE
 CLOSE #1
 EXIT FUNCTION
END IF

GET #1, , Header

FOR i = 1 TO 3
 GET #1, , Player(i)
NEXT i

GET #1, , WorldData

FOR i = 1 TO MAXITEMS
 GET #1, , Items(i)
NEXT i

FOR i = 1 TO MAXDMATRIX
 GET #1, , DMatrix(i)
NEXT i

CLOSE #1

CALL LoadMap(TRUE)
SavedGameLoad = TRUE

END FUNCTION

SUB SaveGameDialog

DIM CurSelection, Action, Desc$(1 TO 4)

FOR i = 1 TO 4
 Temp$ = DQBdir$("saves\data" + Fixed$(i) + ".sav", ATTRIB.A)
 IF LEN(Temp$) THEN
  OPEN "saves\data" + Fixed$(i) + ".sav" FOR BINARY AS #1
  IF LOF(1) = 0 THEN
   Desc$(i) = "[unused]"
  ELSE
   GET #1, , Header
   Desc$(i) = Header
  END IF
  CLOSE #1
 ELSE
  Desc$(i) = "[unused]"
 END IF
NEXT i

CurSelection = 1
Action = TRUE

DO
 kbd$ = INKEY$
 IF kbd$ <> "" THEN
  SELECT CASE kbd$
   CASE CHR$(0) + "H"
    CurSelection = CurSelection - 1
    IF CurSelection = 0 THEN CurSelection = 5
    Action = TRUE
   CASE CHR$(0) + "P"
    CurSelection = CurSelection + 1
    IF CurSelection = 6 THEN CurSelection = 1
    Action = TRUE
   CASE CHR$(13)
    SELECT CASE CurSelection
     CASE 1 TO 4
      EXIT DO
     CASE 5
      SaveGameLoad = FALSE
      EXIT SUB
    END SELECT
   CASE CHR$(27)
    IF CurSelection < 5 THEN
     CurSelection = 5
     Action = TRUE
   ELSE
    SaveGameLoad = FALSE
    EXIT SUB
   END IF
  END SELECT
 END IF
 IF Action THEN
  CALL Box(80, 96, 299, 179)
  CALL PutTextDropShadow("Game Slots:", 31, -1, 104, DROPCOLOUR)
  CALL PutText("Cancel", 31, 96, 168)
  FOR i = 1 TO 4
   CALL PutText(Fixed$(i) + ". " + Desc$(i), 31, 96, 112 + i * 8)
  NEXT i
  IF CurSelection < 5 THEN Row = CurSelection ELSE Row = 7
  CALL PutTextDropShadow("", 31, 88, 112 + Row * 8, DROPCOLOUR)
  CALL BlitScreen
  Action = FALSE
 END IF
LOOP

Header = GetInputBox$(-1, -1, 20, "Comments (20 char max.):")
IF FixedStr$(Header) = "" THEN Header = TIME$ + ", " + DATE$

OPEN "saves\data" + Fixed$(CurSelection) + ".sav" FOR BINARY AS #1

PUT #1, , Header

FOR i = 1 TO 3
 PUT #1, , Player(i)
NEXT i

PUT #1, , WorldData

FOR i = 1 TO MAXITEMS
 PUT #1, , Items(i)
NEXT i

FOR i = 1 TO MAXDMATRIX
 PUT #1, , DMatrix(i)
NEXT i

CLOSE #1

CALL MsgBox(-1, -1, "Game saved in slot " + Fixed$(CurSelection) + ".")

END SUB

SUB Show (Index)

SELECT CASE Index
 CASE 1
  CALL Box(2, 6, 110, 46)
  CALL PutTextDropShadow("Action", 31, 16, 12, 50)
  CALL PutTextDropShadow("Equip", 31, 16, 22, 50)
  CALL PutTextDropShadow("Items", 31, 16, 32, 50)
  CALL PutTextDropShadow("Stats", 31, 70, 12, 50)
  CALL PutTextDropShadow("Magic", 31, 70, 22, 50)
  CALL PutTextDropShadow("Quit", 31, 70, 32, 50)
 
  CALL BaseGUISelItem
 CASE 2
  CALL Box(113, 2, 316, 120)
  CALL PutTextDropShadow("- I t e m s -", 31, 216, 8, 50)

  FOR i = 1 TO 9
   IF WorldData.MenuOffset + i = WorldData.HighItem THEN
    CALL PutTextDropShadow(Items(i + WorldData.MenuOffset).Item, HIGHCOLOUR, 129, i * 10 + 11, DROPCOLOUR)
   ELSE
    CALL PutText(Items(i + WorldData.MenuOffset).Item, 31, 129, i * 10 + 11)
   END IF
   IF Items(i + WorldData.MenuOffset).Quantity THEN CALL PutText(" x " + Fixed$(Items(i + WorldData.MenuOffset).Quantity), 31, 280, i * 10 + 11)
  NEXT i

  CALL PutTextDropShadow("", 31, 120, WorldData.CurOffset * 10 + 11, DROPCOLOUR)

  CALL BlitScreen
 CASE 3
  CALL Box(113, 2, 316, 120)
  CALL PutTextDropShadow("- E q u i p -", 31, 216, 8, 50)
  CALL PutTextDropShadow("Weapons", HIGHCOLOUR, 132, 24, 50)
  CALL PutTextDropShadow("Armor", HIGHCOLOUR, 132, 56, 50)
  CALL BlitScreen
 CASE 4
  CALL Box(113, 2, 316, 120)
  CALL PutTextDropShadow("- M a g i c -", 31, 216, 8, 50)
  CALL BlitScreen
 CASE 5
  CALL Box(113, 2, 316, 180)
  FOR i = 1 TO 3
   CALL DQBput(1, 130 + Player(i).Stance * 10, (i - 1) * 50 + 7, VARSEG(SpriteFace(0, i)), VARPTR(SpriteFace(0, i)))
  NEXT i
  FOR i = 1 TO 3
   CALL PutText(Player(i).CharName, 31, 180 + Player(i).Stance * 10, (i - 1) * 50 + 7)
   CALL PutText("HP: " + Fixed$(Player(i).Hp) + "/" + Fixed$(Player(i).MaxHp), 31, 180 + Player(i).Stance * 10, (i - 1) * 50 + 7 + 8)
   CALL PutText("MP: " + Fixed$(Player(i).Mp) + "/" + Fixed$(Player(i).MaxMp), 31, 180 + Player(i).Stance * 10, (i - 1) * 50 + 7 + 16)
  NEXT i
  CALL PutText("Tals: " + Fixed$(WorldData.Tals), 31, 130, 156)
 CASE 6
  CALL Box(93, 22, 296, 120)
 CASE 7
  CALL DQBClearLayer(1)
  CALL DQBsetPal(LoadPal$("title"))
  Result = DQBloadLayer(1, "images\title\title.mdl", Pal)
END SELECT

END SUB

SUB ShowMap

FOR i = 0 TO 15
 FOR j = 0 TO 9
  CALL DQBfPut(1, i * 20, j * 20, TilesVarseg, VARPTR(Tiles(0, Map(i + WorldData.TopCol, j + WorldData.TopRow).Tile)))
  CALL DQBput(1, i * 20, j * 20, OversVarseg, VARPTR(Overs(0, Map(i + WorldData.TopCol, j + WorldData.TopRow).Over)))
 NEXT j
NEXT i

CALL PutPlayerPic

END SUB

SUB ShowMenu (Index, Reference)

SELECT CASE Index
 CASE 1
  CALL DQBput(1, 110, 27, VARSEG(SpriteFace(0, Reference)), VARPTR(SpriteFace(0, Reference)))
  CALL PutText(Player(Reference).CharName, 31, 158, 27)
  CALL PutText(" HP: " + Fixed$(Player(Reference).Hp) + "/" + Fixed$(Player(Reference).MaxHp) + "  (" + Fixed$(Player(Reference).Level) + ")", 31, 158, 35)
  CALL PutText(" MP: " + Fixed$(Player(Reference).Mp) + "/" + Fixed$(Player(Reference).MaxMp) + "  (" + Fixed$(Player(Reference).MagicLevel) + ")", 31, 158, 43)
  CALL PutText("Exp: " + Fixed$(Player(Reference).Experience), 31, 158, 51)
  CALL PutText("Attack & Defense:", 31, 102, 75)
  CALL PutText("+" + Fixed$(Player(Reference).Attack) + " bonus for " + RTRIM$(Player(Reference).WeaponName) + "  (" + Fixed$(Player(Reference).WeaponDam) + ")", 31, 102, 91)
  CALL PutText("+" + Fixed$(Player(Reference).Wisdom) + " bonus for " + RTRIM$(Player(Reference).ArmorName) + "  (" + Fixed$(Player(Reference).ArmorDam) + ")", 31, 102, 99)
 CASE 2
  CALL Box(113, 2, 316, 120)
  CALL PutTextDropShadow("- M a g i c -", 31, 216, 8, 50)

  FOR i = 1 TO 9
   IF WorldData.MenuOffset + i = WorldData.HighItem THEN
    CALL PutTextDropShadow(Spells(Reference, i + WorldData.MenuOffset).RefName, HIGHCOLOUR, 129, i * 10 + 11, DROPCOLOUR)
   ELSE
    CALL PutText(Spells(Reference, i + WorldData.MenuOffset).RefName, 31, 129, i * 10 + 11)
   END IF
   IF Spells(Reference, i + WorldData.MenuOffset).CastPoints THEN CALL PutText("(" + Fixed$(Spells(Reference, i + WorldData.MenuOffset).CastPoints) + ")", 31, 280, i * 10 + 11)
  NEXT i

  CALL PutTextDropShadow("", 31, 120, WorldData.CurOffset * 10 + 11, DROPCOLOUR)

  CALL BlitScreen

END SELECT

END SUB

SUB ShutDown

CALL DQBclose

SCREEN 0
WIDTH 80, 25
PRINT "An error occurred, or you quit. Have a nice day."
PRINT
PRINT "Indigo Moon pre-release by Tek. (dqb " + Fixed$(DQBver \ &H100) + "." + Fixed$(DQBver AND &HFF) + ")"
PRINT "Refer to moonotes.txt for in-depth info."
END

END SUB

FUNCTION TileName$ (Number)

RecName$ = STRING$(3 - LEN(Fixed$(ABS(Number))), "0") + Fixed$(ABS(Number))
IF Number < 0 THEN TileName$ = "n" + RecName$ ELSE TileName$ = RecName$

END FUNCTION

SUB TryAction
                                                                                           
DIM Msg$

IF CheckFacingTile(PROPOVER) = 0 THEN
 Ido$ = DQBdir$("data\ido\tiles\" + TileName$(CheckFacingTile(PROPTILE)) + ".ido", ATTRIB.A)
 IF LEN(Ido$) THEN
  OPEN "data\ido\tiles\" + Ido$ FOR BINARY AS #1
  GET #1, , Header
  Msg$ = SPACE$(LOF(1) - 64)
  GET #1, , Msg$
  CLOSE #1
 END IF
ELSE
 CALL DialogEngine(FALSE)
 EXIT SUB
END IF

IF Msg$ = "" THEN Msg$ = "You seem to be wasting your time here."

CALL MapMessage(Msg$)
CALL BlitScreen
CALL WaitKey

END SUB

SUB WaitKey

WHILE INKEY$ = ""
WEND

END SUB

FUNCTION YesNoBox (x1, y1, Text$)

DIM Selection, Action

Selection = 1
Action = TRUE

IF x1 = -1 THEN x1 = 116
IF y1 = -1 THEN y1 = 75

CALL Box(x1, y1, x1 + 108, y1 + 50)
CALL PutTextDropShadow(Text$, 31, x1 + 54 - LEN(Text$) * 3, y1 + 8, 50)
CALL PutText("Yes", 31, x1 + 30, y1 + 24)
CALL PutText("No", 31, x1 + 30, y1 + 32)

DO
 kbd$ = INKEY$
 IF kbd$ <> "" THEN
  SELECT CASE kbd$
   CASE CHR$(0) + "H", CHR$(0) + "P"
    Selection = Selection XOR 1
    Action = TRUE
   CASE CHR$(13)
    SELECT CASE Selection
     CASE 0
      YesNoBox = TRUE
     CASE 1
      YesNoBox = FALSE
    END SELECT
    EXIT DO
  END SELECT
 END IF
 IF Action THEN
  FOR i = 0 TO 1
   CALL PutTextDropShadow("", BOXBG, x1 + 24, y1 + 24 + i * 8, BOXBG)
  NEXT i
  CALL PutTextDropShadow("", 31, x1 + 24, y1 + 24 + Selection * 8, DROPCOLOUR)
  CALL BlitScreen
  Action = FALSE
 END IF
LOOP

END FUNCTION

