' Notes & Todo: 
' more flexible context menus
' context sens menus: set cons, make igr, tile dropper, draw w/schems
' caption$=cur.cons, if nothing then cons remains. tools: flush all cons,
'   flush overlay, etc.
' doublecheck map cons inp
' add option to speckle func, schematics fix
' sub changetile(ws)
' finalize/selector on loadmapdialog/.
' track extra cons.. side-effect?
' menu turns on schematics
' dump vars in type(s)
' all reactionary keys:
'  /,*,+,-,=,_,pgup,pdwn,home,end,esc->q,s,n,l
' manually set the CONS ref on overtiles
' double check water schems
' key shortcuts for menus
' macros
'

DEFINT A-Z
'$INCLUDE: '..\data\resource\directqb.bi'
DECLARE SUB Bevel (Target, x1, y1, x2, y2, Look, BgCol)
DECLARE SUB BlitGet ()
DECLARE SUB BlitScreen ()
DECLARE SUB DecideKeys ()
DECLARE SUB DecideMenus ()
DECLARE SUB DecideMouse ()
DECLARE SUB DoMenu (Index, Item)
DECLARE SUB DrawHandleClick (Index, Item, x, y, Elements)
DECLARE SUB DrawHandleMenu (Index, Elements, x, y)
DECLARE SUB FlushMap (Tile)
DECLARE SUB InitStuff ()
DECLARE SUB InitVars ()
DECLARE SUB LoadMap (MapName$)
DECLARE SUB LoadMapDialog ()
DECLARE SUB LoadTiles ()
DECLARE SUB SaveMapBinary (MapName$)
DECLARE SUB SetupScreen ()
DECLARE SUB ShowStats ()
DECLARE SUB ShowGrid ()
DECLARE SUB ShowMap ()
DECLARE SUB ShowWorkClear ()
DECLARE SUB ShowPalette ()
DECLARE SUB ShutDown ()
DECLARE SUB TextShadow (Layer, Text$, x, y, Colour, Style)
DECLARE SUB WaitKey ()
DECLARE SUB WaterSchematics ()
DECLARE FUNCTION Fixed$ (Number)
DECLARE FUNCTION FixedStr$ (Strin$)
DECLARE FUNCTION GetInput$ (Column, Row, MaxLength, Text$)
DECLARE FUNCTION GetInputBox$ (Column, Row, MaxLength, Caption$, Text$)
DECLARE FUNCTION InRange (x1, y1, x2, y2)
DECLARE FUNCTION InXRange (x1, x2)
DECLARE FUNCTION InYRange (y1, y2)
DECLARE FUNCTION TileName$ (Number)

TYPE MapType
 Tile           AS INTEGER
 Over           AS INTEGER
 Cons           AS INTEGER
END TYPE

TYPE MapInfoType
 Rows           AS INTEGER
 Cols           AS INTEGER
 TopCol         AS INTEGER
 TopRow         AS INTEGER
 CurTile        AS INTEGER
 CurOverTile    AS INTEGER
 CurPalette     AS INTEGER
 Grid           AS INTEGER
 xBase          AS INTEGER
 yBase          AS INTEGER
 Schematics     AS INTEGER
 MouseClick     AS INTEGER
 xVal           AS INTEGER
 yVal           AS INTEGER
 MapName        AS STRING * 8
END TYPE

CONST TRUE = -1
CONST FALSE = NOT TRUE
CONST COLDARK = 16 * 15 + 6
CONST COLLIGHT = COLDARK + 6
CONST COLPANEL = (COLDARK + COLLIGHT) / 2
CONST NUMTILESWALKON = 18
CONST NUMTILESWALKOFF = -14
CONST NUMOVERSWALKOFF = -3
CONST NUMOVERSWALKON = 8
CONST NUMMENUS = 3
CONST MAXMENUITEMS = 14

DIM SHARED Tiles(201, NUMTILESWALKOFF TO NUMTILESWALKON)
DIM SHARED Overs(201, NUMOVERSWALKOFF TO NUMOVERSWALKON)
DIM SHARED Menu$(1 TO NUMMENUS + 1, MAXMENUITEMS)
DIM SHARED MapInfo AS MapInfoType
DIM SHARED Map(1 TO 60, 1 TO 60) AS MapType
DIM SHARED Font AS STRING * 2305
DIM SHARED Pal AS STRING * 768
DIM SHARED Header AS STRING * 64

CALL InitStuff

DO
 CALL DecideKeys
 CALL DecideMouse
 CALL DQBWait(1)
LOOP





' Miscellaneous Program Data 

MenuData:
DATA "*","File","Tools"
DATA "Keys...","-","About...","NUL"
DATA "New","Open...","Save","Save as...","Close","-","Exit","NUL"
DATA "Speckle...","Preview","Schematics","NUL"
DATA "Set cons...","Make igr...","Tile dropper","NUL"

SUB Bevel (Target, x1, y1, x2, y2, Look, BgCol)

IF Target < 0 THEN Target = VIDEO

IF Look = 1 OR Look = 3 THEN
 Col1 = COLLIGHT
 Col2 = COLDARK
ELSEIF Look = 2 OR Look = 4 THEN
 Col1 = COLDARK
 Col2 = COLLIGHT
END IF

CALL DQBLine(Target, x1, y1, x2 - 1, y1, Col1)
CALL DQBLine(Target, x1, y1, x1, y2 - 1, Col1)
CALL DQBLine(Target, x2, y1, x2, y2 - 1, Col2)
CALL DQBLine(Target, x1, y2, x2, y2, Col2)

IF Look = 3 OR Look = 4 THEN
 CALL DQBPset(Target, x1, y2, COLPANEL)
 CALL DQBPset(Target, x2, y1, COLPANEL)
 CALL DQBLine(Target, x1 + 1, y2 + 1, x2, y2 + 1, 0)
 CALL DQBLine(Target, x2 + 1, y1 + 1, x2 + 1, y2, 0)
END IF

IF BgCol <> -1 THEN CALL DQBBoxF(Target, x1 + 1, y1 + 1, x2 - 1, y2 - 1, BgCol)

END SUB

SUB BlitGet

CALL DQBMouseHide
CALL DQBCopyLayer(VIDEO, 1)
CALL DQBMouseShow

END SUB

SUB BlitScreen

CALL DQBMouseHide
CALL DQBCopyLayer(1, VIDEO)
CALL DQBMouseShow

END SUB

SUB DecideKeys

kbd$ = INKEY$
IF kbd$ = "" THEN EXIT SUB

SELECT CASE kbd$
 CASE "*"
  IF MapInfo.CurPalette = 1 THEN MapInfo.CurPalette = 2 ELSE MapInfo.CurPalette = 1
  CALL ShowPalette
 CASE "-", "_"
  SELECT CASE MapInfo.CurPalette
   CASE 1
    MapInfo.CurTile = MapInfo.CurTile - 1
    IF MapInfo.CurTile < NUMTILESWALKOFF THEN MapInfo.CurTile = NUMTILESWALKOFF
   CASE 2
    MapInfo.CurOverTile = MapInfo.CurOverTile - 1
    IF MapInfo.CurOverTile < NUMOVERSWALKOFF THEN MapInfo.CurOverTile = NUMOVERSWALKOFF
  END SELECT
  CALL ShowPalette
 CASE "+", "="
  SELECT CASE MapInfo.CurPalette
   CASE 1
    MapInfo.CurTile = MapInfo.CurTile + 1
    IF MapInfo.CurTile > NUMTILESWALKON THEN MapInfo.CurTile = NUMTILESWALKON
   CASE 2
    MapInfo.CurOverTile = MapInfo.CurOverTile + 1
    IF MapInfo.CurOverTile > NUMOVERSWALKON THEN MapInfo.CurOverTile = NUMOVERSWALKON
  END SELECT
  CALL ShowPalette
 CASE CHR$(0) + "H"
  MapInfo.TopRow = MapInfo.TopRow - 1
  IF MapInfo.TopRow < 1 THEN MapInfo.TopRow = 1
  Action = TRUE
 CASE CHR$(0) + "P"
  MapInfo.TopRow = MapInfo.TopRow + 1
  IF MapInfo.TopRow > 53 THEN MapInfo.TopRow = 53
  Action = TRUE
 CASE CHR$(0) + "M"
  MapInfo.TopCol = MapInfo.TopCol + 1
  IF MapInfo.TopCol > 48 THEN MapInfo.TopCol = 48
  Action = TRUE
 CASE CHR$(0) + "K"
  MapInfo.TopCol = MapInfo.TopCol - 1
  IF MapInfo.TopCol < 1 THEN MapInfo.TopCol = 1
  Action = TRUE
 CASE CHR$(0) + "G"
  MapInfo.TopCol = 1
  Action = TRUE
 CASE CHR$(0) + "O"
  MapInfo.TopCol = 48
  Action = TRUE
 CASE CHR$(0) + "I"
  MapInfo.TopRow = 1
  Action = TRUE
 CASE CHR$(0) + "Q"
  MapInfo.TopRow = 53
  Action = TRUE
END SELECT

IF Action THEN
 CALL ShowStats
 CALL ShowMap
 Action = FALSE
END IF

END SUB

SUB DecideMenus

DIM Length

FOR i = 1 TO NUMMENUS
 IF InXRange(Length + 5, Length + DQBlen(Menu$(i, 0)) + 12) THEN
  CALL DQBMouseHide
  CALL DQBBoxF(VIDEO, Length + 3, 0, Length + DQBlen(Menu$(i, 0)) + 12, 10, COLDARK)
  CALL TextShadow(VIDEO, Menu$(i, 0), Length + 8, 1, 30, NONE)
  CALL DQBMouseShow
  FOR j = 1 TO 10
   IF Menu$(i, j) = "NUL" THEN EXIT FOR
  NEXT j
  CALL DrawHandleMenu(i, j - 1, Length, 12)
  CALL DQBMouseHide
  CALL DQBBoxF(VIDEO, Length + 3, 0, Length + DQBlen(Menu$(i, 0)) + 12, 10, COLPANEL)
  CALL TextShadow(VIDEO, Menu$(i, 0), Length + 8, 1, 31, NONE)
  CALL DQBMouseShow
  EXIT FOR
 END IF
 Length = Length + DQBlen(Menu$(i, 0) + "  ")
NEXT i

END SUB

SUB DecideMouse

SELECT CASE DQBmouseLB
 CASE -1
  IF InYRange(0, 10) THEN
   IF MapInfo.MouseClick = FALSE THEN
    CALL DecideMenus
   END IF
  ELSEIF InYRange(11, 199) THEN
   MapInfo.MouseClick = TRUE
    IF InRange(6, 18, 287, 184) THEN
     MapInfo.xVal = -1
     MapInfo.yVal = -1
  
     FOR i = 0 TO 12
      IF InXRange(i * 21 + MapInfo.xBase, i * 21 + MapInfo.xBase + 20) THEN MapInfo.xVal = i
      IF InYRange(i * 21 + MapInfo.yBase, i * 21 + MapInfo.yBase + 20) THEN MapInfo.yVal = i
     NEXT i
 
     CALL DQBMouseHide
     IF MapInfo.xVal <> -1 AND MapInfo.yVal <> -1 THEN
      SELECT CASE MapInfo.CurPalette
       CASE 1
        CALL DQBfPut(VIDEO, MapInfo.xVal * 21 + MapInfo.xBase + 1, MapInfo.yVal * 21 + MapInfo.yBase + 1, VARSEG(Tiles(0, MapInfo.CurTile)), VARPTR(Tiles(0, MapInfo.CurTile)))
        CALL DQBPut(VIDEO, MapInfo.xVal * 21 + MapInfo.xBase + 1, MapInfo.yVal * 21 + MapInfo.yBase + 1, VARSEG(Overs(0, 0)), VARPTR(Overs(0, Map(MapInfo.TopCol + MapInfo.xVal, MapInfo.TopRow + MapInfo.yVal).Over)))
        Map(MapInfo.xVal + MapInfo.TopCol, MapInfo.yVal + MapInfo.TopRow).Tile = MapInfo.CurTile
       CASE 2
        CALL DQBPut(VIDEO, MapInfo.xVal * 21 + MapInfo.xBase + 1, MapInfo.yVal * 21 + MapInfo.yBase + 1, VARSEG(Overs(0, 0)), VARPTR(Overs(0, Map(MapInfo.TopCol + MapInfo.xVal, MapInfo.TopRow + MapInfo.yVal).Over)))
        Map(MapInfo.xVal + MapInfo.TopCol, MapInfo.yVal + MapInfo.TopRow).Over = MapInfo.CurOverTile
      END SELECT
      CALL ShowStats
      IF MapInfo.Schematics THEN
       IF MapInfo.CurTile = -1 AND MapInfo.CurPalette = 1 THEN CALL WaterSchematics
      END IF
     END IF
     CALL DQBMouseShow
    END IF
  END IF
 CASE 0
  MapInfo.MouseClick = FALSE
END SELECT

SELECT CASE DQBmouseRB
 CASE -1
  IF InRange(6, 18, 287, 184) THEN
   MapInfo.xVal = -1
   MapInfo.yVal = -1
 
   FOR i = 0 TO 12
    IF InXRange(i * 21 + MapInfo.xBase, i * 21 + MapInfo.xBase + 20) THEN MapInfo.xVal = i
    IF InYRange(i * 21 + MapInfo.yBase, i * 21 + MapInfo.yBase + 20) THEN MapInfo.yVal = i
   NEXT i
  
   x = DQBmouseX
   y = DQBmouseY
   CALL DrawHandleMenu(4, 3, x, y)
  
  END IF
END SELECT

END SUB

SUB DoMenu (Index, Item)

Temp$ = LCASE$(Menu$(Index, Item))

SELECT CASE LCASE$(Menu$(Index, 0))
 CASE "file"
  SELECT CASE Temp$
   CASE "new"
    Tile$ = GetInputBox$(40, 40, 4, "Base tile:", "")
    IF Tile$ <> "" THEN
     CALL FlushMap(VAL(Tile$))
     MapInfo.MapName = "newmap"
     CALL ShowMap
    END IF
   CASE "open..."
    CALL LoadMapDialog
   CASE "save"
    IF FixedStr$(MapInfo.MapName) <> "" THEN CALL SaveMapBinary(FixedStr$(MapInfo.MapName))
   CASE "save as..."
    MapSave$ = GetInputBox$(40, 40, 20, "Save Map As (no .imm):", FixedStr$(MapInfo.MapName))
    IF FixedStr$(MapSave$) = "" THEN MapSave$ = FixedStr$(MapInfo.MapName)
    CALL SaveMapBinary(MapSave$)
   CASE "close"
    CALL FlushMap(0)
    MapInfo.MapName = "newmap"
    CALL ShowMap
   CASE "exit"
    CALL ShutDown
  END SELECT
 CASE "tools"
  SELECT CASE Temp$
   CASE "speckle..."
    Speckle$ = GetInputBox$(40, 40, 4, "Tile " + Fixed$(MapInfo.CurTile) + ", speckle density:", "10%")
    IF RIGHT$(Speckle$, 1) = "%" THEN
     Tiles = 36 * VAL(LEFT$(Speckle$, LEN(Speckle$) - 1)) + 1
    ELSE
     Tiles = VAL(Speckle$)
    END IF
    FOR i = 1 TO Tiles
     Map(INT(RND * 60 + 1), INT(RND * 60) + 1).Tile = MapInfo.CurTile
    NEXT i
    CALL ShowMap
    CALL ShowStats
   CASE "preview"
    CALL DQBMouseHide
    CALL DQBCopyLayer(VIDEO, 1)
    CALL Bevel(VIDEO, 68, 8, 257, 197, 1, COLPANEL)
    CALL Bevel(VIDEO, 70, 10, 255, 195, 2, 0)
    FOR i = 1 TO 60
     FOR j = 1 TO 60
      SVarSeg = VARSEG(Tiles(0, 0))
      SVarPtr = VARPTR(Tiles(0, Map(i, j).Tile))
      CALL DQBsPut(VIDEO, (i * 3) + 70, (j * 3) + 10, SVarSeg, SVarPtr, 3, 3)
     NEXT j
    NEXT i
    CALL DQBMouseShow
    CALL WaitKey
    CALL DQBMouseHide
    CALL DQBCopyLayer(1, VIDEO)
    CALL DQBMouseShow
   
  END SELECT

 CASE ELSE
  SELECT CASE Temp$
   CASE "set cons..."
    Map(MapInfo.xVal + MapInfo.TopCol, MapInfo.yVal + MapInfo.TopRow).Cons = VAL(GetInputBox$(40, 40, 10, "Enter tile cons: (" + Fixed$(Map(MapInfo.xVal + MapInfo.TopCol, MapInfo.yVal + MapInfo.TopRow).Cons) + "):", ""))
    CALL ShowMap

  END SELECT
END SELECT

CALL ShowStats

END SUB

SUB DrawHandleClick (Index, Item, x, y, Elements)

DIM Length

IF Item = 0 THEN
 CALL BlitScreen
 EXIT SUB
END IF

Length = 0

SELECT CASE InYRange(0, 10)
 CASE TRUE
  CALL BlitScreen
  EXIT SUB
 CASE FALSE
  IF InRange(x, y + 1, x + 72, Elements * 10 + y + 1) THEN
   CALL DQBMouseHide
   FOR i = 1 TO 3
    CALL DQBBoxF(VIDEO, x + 1, Item * 10 + y - 9, x + 71, Item * 10 + y, COLDARK)
    CALL DQBPrints(VIDEO, Menu$(Index, Item), x + 3, y + 2 + ((Item - 1) * 10), 30, ITALIC)
    CALL DQBWait(4)
    CALL DQBBoxF(VIDEO, x + 1, Item * 10 + y - 9, x + 71, Item * 10 + y, 0)
    CALL DQBPrints(VIDEO, Menu$(Index, Item), x + 3, y + 2 + ((Item - 1) * 10), 30, ITALIC)
    CALL DQBWait(4)
   NEXT i
   CALL DQBMouseShow
  END IF
  CALL BlitScreen
  CALL DoMenu(Index, Item)
END SELECT

END SUB

SUB DrawHandleMenu (Index, Elements, x, y)

DIM StillClicked, OldHighLight

CALL BlitGet

CALL DQBMouseHide

CALL Bevel(VIDEO, x, y, x + 72, Elements * 10 + y + 1, 3, COLPANEL)

FOR i = 1 TO Elements
 IF Menu$(Index, i) <> "-" THEN
  CALL DQBPrint(VIDEO, Menu$(Index, i), x + 3, y + 2 + ((i - 1) * 10), 15)
 ELSE
  CALL Bevel(VIDEO, x + 1, y + 5 + ((i - 1) * 10), x + 71, y + 6 + ((i - 1) * 10), 1, -1)
 END IF
NEXT i

CALL DQBMouseShow

IF DQBmouseLB THEN StillClicked = TRUE

DO
 SELECT CASE DQBmouseLB
  CASE -1
   IF StillClicked = FALSE THEN
    IF InRange(x, y, x + 71, Elements * 10 + y + 1) AND Menu$(Index, OldHighLight) <> "-" THEN
     CALL DrawHandleClick(Index, OldHighLight, x, y, Elements)
     EXIT DO
    ELSEIF InRange(x, y, x + 71, Elements * 10 + y + 1) THEN
    ELSE
     CALL BlitScreen
     MapInfo.MouseClick = TRUE
     EXIT DO
    END IF
   END IF
  CASE 0
   IF StillClicked THEN
    IF InRange(x, y, x + 71, Elements * 10 + y + 1) AND Menu$(Index, OldHighLight) <> "-" THEN
     CALL DrawHandleClick(Index, OldHighLight, x, y, Elements)
     EXIT DO
    ELSE
     StillClicked = FALSE
    END IF
   END IF

 END SELECT

 IF InXRange(x, x + 72) THEN
  FOR i = 1 TO Elements
   IF InYRange(i * 10 + y - 9, i * 10 + y) THEN
    IF i <> OldHighLight THEN
     CALL DQBMouseHide
     IF OldHighLight AND Menu$(Index, OldHighLight) <> "-" THEN
      CALL DQBBoxF(VIDEO, x + 1, OldHighLight * 10 + y - 9, x + 71, OldHighLight * 10 + y, COLPANEL)
      CALL DQBPrint(VIDEO, Menu$(Index, OldHighLight), x + 3, y + 2 + ((OldHighLight - 1) * 10), 31)
     END IF
     IF Menu$(Index, i) <> "-" THEN
      CALL DQBBoxF(VIDEO, x + 1, i * 10 + y - 9, x + 71, i * 10 + y, 0)
      CALL DQBPrints(VIDEO, Menu$(Index, i), x + 3, y + 2 + ((i - 1) * 10), 30, ITALIC)
     END IF
     CALL DQBMouseShow
     OldHighLight = i
    END IF
   END IF
  NEXT i
 END IF
LOOP

END SUB

FUNCTION Fixed$ (Number)

Fixed$ = LTRIM$(RTRIM$(STR$(Number)))

END FUNCTION

FUNCTION FixedStr$ (Strin$)

FixedStr$ = LTRIM$(RTRIM$(Strin$))

END FUNCTION

SUB FlushMap (Tile)

IF Tile < NUMTILESWALKOFF OR Tile > NUMTILESWALKON THEN Tile = 0

FOR i = 1 TO 60
 FOR j = 1 TO 60
  Map(i, j).Tile = Tile
  Map(i, j).Over = 0
  Map(i, j).Cons = 0
 NEXT j
NEXT i

END SUB

FUNCTION GetInput$ (Column, Row, MaxLength, Text$)

DIM Inpt$, Length, Key$

Inpt$ = Text$
Length = LEN(Text$)

CALL DQBMouseHide
CALL DQBPrint(VIDEO, Inpt$, Column, Row, 31)
CALL DQBMouseShow

DO
 kbd$ = INKEY$
 IF kbd$ <> "" THEN
  SELECT CASE kbd$
   CASE CHR$(8)
    IF Length > 0 THEN Length = Length - 1
    Inpt$ = LEFT$(Inpt$, Length)
   CASE CHR$(27)
    Inpt$ = ""
    EXIT DO
   CASE CHR$(13)
    EXIT DO
   CASE ELSE
    IF ASC(kbd$) > 31 AND ASC(kbd$) < 128 THEN
     IF Length < MaxLength THEN
      Inpt$ = Inpt$ + kbd$
      Length = Length + 1
     END IF
    END IF
  END SELECT
 
  CALL DQBMouseHide
 
  CALL DQBBoxF(VIDEO, Column, Row, Column + DQBlen(Inpt$) + 8, Row + 8, COLPANEL)
  CALL DQBPrint(VIDEO, Inpt$, Column, Row, 31)

  CALL DQBMouseShow

 END IF

LOOP

GetInput$ = FixedStr$(Inpt$)

END FUNCTION

FUNCTION GetInputBox$ (Column, Row, MaxLength, Caption$, Text$)

IF MaxLength * 6 > DQBlen(Caption$) THEN Size = MaxLength * 6 ELSE Size = DQBlen(Caption$)

IF Column = -1 THEN
 Column = 160 - (((Size * 6) + 16) / 2)
END IF
IF Row = -1 THEN
 Row = 87
END IF

CALL BlitGet

CALL DQBMouseHide

CALL Bevel(VIDEO, Column, Row, Size + 16 + Column, Row + 26, 1, COLPANEL)
CALL DQBPrint(VIDEO, Caption$, Column + 5, Row + 5, 31)

CALL DQBMouseShow

GetInputBox$ = GetInput$(Column + 5, Row + 13, MaxLength, Text$)

CALL BlitScreen

END FUNCTION

SUB InitStuff

PRINT "Mappy 3.0 loadup:"
PRINT "Initializing..."

IF DQBinit(1, 0) <> 0 THEN CALL ShutDown
IF DQBMoustInit <> 0 THEN CALL ShutDown

RANDOMIZE TIMER

CALL InitVars
CALL LoadTiles

OPEN "..\data\fonts\8xpoly.fnt" FOR BINARY AS #1
GET #1, , Font
CLOSE #1
CALL DQBSetFont(Font)

SCREEN 13
COLOR 15
CALL DQBresetMouse

OPEN "..\images\palettes\nmedia.pal" FOR BINARY AS #1
GET #1, , Pal
CLOSE #1

CALL DQBsetPal(Pal)

CALL SetupScreen

CALL DQBMouseShow

CALL ShowPalette

END SUB

SUB InitVars

Mouse$ = SPACE$(57)

MapInfo.TopCol = 1
MapInfo.TopRow = 1
MapInfo.CurTile = 1
MapInfo.CurOverTile = 0
MapInfo.CurPalette = 1
MapInfo.Grid = 17
MapInfo.xBase = 5
MapInfo.yBase = 17
MapInfo.Rows = 60
MapInfo.Cols = 60
MapInfo.Schematics = TRUE
MapInfo.MapName = "new"

RESTORE MenuData

FOR i = 1 TO NUMMENUS
 READ Menu$(i, 0)
NEXT i

Count = 0

FOR i = 1 TO NUMMENUS + 1
 FOR j = 1 TO UBOUND(Menu$, 2)
  READ Menu$(i, j)
  IF Menu$(i, j) = "NUL" THEN EXIT FOR
 NEXT j
NEXT i


END SUB

FUNCTION InRange (x1, y1, x2, y2)

x = DQBmouseX
y = DQBmouseY
IF x >= x1 AND y >= y1 AND x <= x2 AND y <= y2 THEN InRange = TRUE

END FUNCTION

FUNCTION InXRange (x1, x2)

x = DQBmouseX
IF x >= x1 AND x <= x2 THEN InXRange = -1

END FUNCTION

FUNCTION InYRange (y1, y2)

y = DQBmouseY
IF y >= y1 AND y <= y2 THEN InYRange = -1

END FUNCTION

SUB LoadMap (MapName$)

IF MapName$ = "" THEN
 CALL ShowWorkClear
 CALL ShowGrid
 CALL ShowMap
 EXIT SUB
END IF

FullMap$ = "..\maps\" + RTRIM$(LTRIM$(MapName$)) + ".imm"

OPEN FullMap$ FOR BINARY AS #1

IF LOF(1) = 0 THEN
 CLOSE #1
 KILL FullMap$
ELSE
 MapInfo.MapName = MapName$
 GET #1, , Header
 GET #1, , MapInfo.Rows
 GET #1, , MapInfo.Cols
 FOR i = 1 TO MapInfo.Rows
  FOR j = 1 TO MapInfo.Cols
   GET #1, , Map(j, i)
  NEXT j
 NEXT i
END IF

CLOSE #1

CALL ShowWorkClear
CALL ShowGrid
CALL ShowMap

END SUB

SUB LoadMapDialog

DIM MapFiles$(1000), Count

Count = 0

File$ = DQBdir$("..\Maps\*.imm", ATTRIB.A)
MapFiles$(Count) = LEFT$(File$, INSTR(File$, ".") - 1)

IF MapFiles$(Count) = "" THEN
 LOCATE 3, 1
 PRINT "No .imm files found!"
 CALL ShowStats
 EXIT SUB
ELSE
 Count = Count + 1
 DO
  File$ = DQBdir$("", ATTRIB.A)
  IF INSTR(File$, ".") THEN MapFiles$(Count) = LEFT$(File$, INSTR(File$, ".") - 1)
  IF MapFiles$(Count) = "" THEN EXIT DO
  Count = Count + 1
 LOOP
END IF

LOCATE 3, 1

CALL ShowWorkClear
CALL DQBMouseHide

FOR i = 0 TO 20
 PRINT LCASE$(MapFiles$(i));
 LOCATE , 10
 PRINT MapFiles$(i + 20);
 LOCATE , 19
 PRINT MapFiles$(i + 40);
 LOCATE , 28
 IF i = 20 THEN PRINT MapFiles$(i + 60);  ELSE PRINT MapFiles$(i + 60)
NEXT i

CALL DQBMouseHide

MapName$ = GetInputBox$(100, 100, 8, "Load map (no .imm):", "")

CALL LoadMap(MapName$)
CALL ShowStats

END SUB

SUB LoadTiles

FOR i = NUMTILESWALKOFF TO NUMTILESWALKON
 DEF SEG = VARSEG(Tiles(0, i))
 BLOAD "..\images\tiles\" + TileName$(i), VARPTR(Tiles(0, i))
NEXT i

FOR i = NUMOVERSWALKOFF TO NUMOVERSWALKON
 DEF SEG = VARSEG(Overs(0, i))
 BLOAD "..\images\overs\" + TileName$(i), VARPTR(Overs(0, i))
NEXT i

DEF SEG

END SUB

SUB SaveMapBinary (MapName$)

OPEN "..\maps\" + LCASE$(LTRIM$(RTRIM$(MapName$))) + ".imm" FOR BINARY AS #1

PUT #1, , Header
PUT #1, , MapInfo.Rows
PUT #1, , MapInfo.Cols

FOR i = 1 TO 60
 FOR j = 1 TO 60
  PUT #1, , Map(j, i)
 NEXT j
NEXT i

CLOSE #1

END SUB

SUB SetupScreen

CALL DQBBoxF(VIDEO, 0, 0, 319, 10, COLPANEL)
CALL DQBLine(VIDEO, 0, 11, 289, 11, COLDARK)
CALL DQBLine(VIDEO, 284, 11, 284, 199, COLLIGHT)
CALL DQBBoxF(VIDEO, 285, 11, 319, 199, COLPANEL)

FOR i = 1 TO NUMMENUS
 FullMenu$ = FullMenu$ + Menu$(i, 0) + "  "
NEXT i

CALL TextShadow(VIDEO, FullMenu$, 8, 1, 31, NONE)

CALL Bevel(VIDEO, 291, 6, 314, 167, 2, 0)
CALL Bevel(VIDEO, 291, 172, 314, 195, 2, 0)

CALL DQBLine(VIDEO, 293, 75, 312, 75, 15)
CALL DQBLine(VIDEO, 293, 98, 312, 98, 15)

CALL ShowGrid
CALL ShowMap

END SUB

SUB ShowGrid

CALL DQBMouseHide

FOR i = 0 TO 12
 FOR j = 0 TO 7
  LINE (i * 21 + MapInfo.xBase, j * 21 + MapInfo.yBase)-STEP(21, 21), MapInfo.Grid, B
 NEXT j
NEXT i

CALL DQBMouseShow

END SUB

SUB ShowMap

CALL DQBMouseHide

FOR i = 0 TO 12
 FOR j = 0 TO 7
  CALL DQBfPut(VIDEO, i * 21 + MapInfo.xBase + 1, j * 21 + MapInfo.yBase + 1, VARSEG(Tiles(0, 0)), VARPTR(Tiles(0, Map(i + MapInfo.TopCol, j + MapInfo.TopRow).Tile)))
  CALL DQBPut(VIDEO, i * 21 + MapInfo.xBase + 1, j * 21 + MapInfo.yBase + 1, VARSEG(Overs(0, 0)), VARPTR(Overs(0, Map(i + MapInfo.TopCol, j + MapInfo.TopRow).Over)))
  IF Map(i + MapInfo.TopCol, j + MapInfo.TopRow).Cons <> 0 THEN CALL DQBPset(VIDEO, i * 21 + MapInfo.xBase + 1, j * 21 + MapInfo.yBase + 1, 4)
 NEXT j
NEXT i

CALL DQBMouseShow

END SUB

SUB ShowPalette

CALL DQBMouseHide

Count = 1

SELECT CASE MapInfo.CurPalette
 CASE 1
  FOR i = MapInfo.CurTile - 3 TO MapInfo.CurTile + 3
   IF i > NUMTILESWALKON OR i < NUMTILESWALKOFF THEN
    PUT (293, Count * 23 - 15), Tiles(0, 0), PSET
   ELSE
    PUT (293, Count * 23 - 15), Tiles(0, i), PSET
   END IF
   Count = Count + 1
  NEXT i
  PUT (293, 174), Tiles(0, MapInfo.CurTile), PSET
 CASE 2
  FOR i = MapInfo.CurOverTile - 3 TO MapInfo.CurOverTile + 3
   IF i > NUMOVERSWALKON OR i < NUMOVERSWALKOFF THEN
    PUT (293, Count * 23 - 15), Overs(0, 0), PSET
   ELSE
    PUT (293, Count * 23 - 15), Overs(0, i), PSET
   END IF
   Count = Count + 1
  NEXT i
  PUT (293, 174), Overs(0, MapInfo.CurOverTile), PSET
END SELECT

CALL ShowStats

CALL DQBMouseShow

END SUB

SUB ShowStats
                
Text$ = FixedStr$(MapInfo.MapName) + ".imm: Tile: "

IF MapInfo.CurPalette = 1 THEN Tile$ = Fixed$(MapInfo.CurTile) ELSE Tile$ = Fixed$(MapInfo.CurOverTile)

Text$ = Text$ + Fixed$(MapInfo.CurPalette) + "/" + Tile$ + ", "

Text$ = Text$ + "(" + Fixed$(MapInfo.xVal + MapInfo.TopCol) + ", " + Fixed$(MapInfo.yVal + MapInfo.TopRow) + ")"

Text$ = Text$ + "     "

CALL DQBMouseHide

CALL DQBPrints(VIDEO, Text$, 0, 191, 31, SOLID)

CALL DQBMouseShow

END SUB

SUB ShowWorkClear

CALL DQBMouseHide
CALL DQBBoxF(VIDEO, 0, 12, 283, 199, 0)
CALL DQBMouseShow

END SUB

SUB ShutDown

CALL DQBclose
   
SCREEN 0
WIDTH 80, 25
PRINT "You quit the program, or program execution was terminated due to an error;"
PRINT "this may have happened with the mouse routines."
PRINT
PRINT "See ya later."
END

END SUB

SUB TextShadow (Layer, Text$, x, y, Colour, Style)

IF x = -1 THEN x = 160 - DQBlen(Text$) / 2

CALL DQBPrints(Layer, Text$, x + 1, y + 1, Colour - 8, Style)
CALL DQBPrints(Layer, Text$, x, y, Colour, Style)

END SUB

FUNCTION TileName$ (Number)

RecName$ = STRING$(3 - LEN(Fixed$(ABS(Number))), "0") + Fixed$(ABS(Number)) + ".mdt"
IF Number < 0 THEN TileName$ = "n" + RecName$ ELSE TileName$ = RecName$

END FUNCTION

SUB WaitKey

WHILE INKEY$ = ""
WEND

END SUB

SUB WaterSchematics
EXIT SUB
Col = MapInfo.xVal + MapInfo.TopCol
Row = MapInfo.yVal + MapInfo.TopRow

IF Map(Col, Row - 2).Tile = -1 THEN Map(Col, Row - 1).Tile = -1
IF Map(Col, Row + 2).Tile = -1 THEN Map(Col, Row + 1).Tile = -1
IF Map(Col + 2, Row).Tile = -1 THEN Map(Col + 1, Row).Tile = -1
IF Map(Col - 2, Row).Tile = -1 THEN Map(Col - 1, Row).Tile = -1

' Basic schematics

SELECT CASE Map(Col, Row - 1).Tile
 CASE 6, 10
  Map(Col, Row - 1).Tile = 11
 CASE 5, 9
  Map(Col, Row - 1).Tile = 10
 CASE IS <> -1
  Map(Col, Row - 1).Tile = 3
END SELECT

SELECT CASE Map(Col, Row + 1).Tile
 CASE 6, 8
  Map(Col, Row + 1).Tile = 8
 CASE 5, 7
  Map(Col, Row + 1).Tile = 7
 CASE IS <> -1
  Map(Col, Row + 1).Tile = 4
END SELECT

SELECT CASE Map(Col - 1, Row).Tile
 CASE 3, 10
  Map(Col - 1, Row).Tile = 10
 CASE 4, 8
  Map(Col - 1, Row).Tile = 8
 CASE IS <> -1
  Map(Col - 1, Row).Tile = 6
END SELECT

SELECT CASE Map(Col + 1, Row).Tile
 CASE 3, 9
  Map(Col + 1, Row).Tile = 9
 CASE 4, 7
  Map(Col + 1, Row).Tile = 7
 CASE IS <> -1
  Map(Col + 1, Row).Tile = 5
END SELECT

' Corner schematics

SELECT CASE Map(Col, Row - 1).Tile
 CASE 3, 10, 9
  SELECT CASE Map(Col - 1, Row).Tile
   CASE 6, 10
    Map(Col - 1, Row - 1).Tile = 14
  END SELECT
  SELECT CASE Map(Col + 1, Row).Tile
   CASE 5, 9
    Map(Col + 1, Row - 1).Tile = 13
  END SELECT
END SELECT

SELECT CASE Map(Col, Row + 1).Tile
 CASE 4, 8, 7
  SELECT CASE Map(Col - 1, Row).Tile
   CASE 6, 8
    Map(Col - 1, Row + 1).Tile = 12
  END SELECT
  SELECT CASE Map(Col + 1, Row).Tile
   CASE 5, 7
    Map(Col + 1, Row + 1).Tile = 11
  END SELECT
END SELECT

' Advanced schematics

SELECT CASE Map(Col + 2, Row - 1).Tile
 CASE 4, 8, 11
  SELECT CASE Map(Col + 1, Row).Tile
   CASE 5, 9, 13
    Map(Col + 1, Row - 1).Tile = 7
  END SELECT
END SELECT

SELECT CASE Map(Col - 2, Row - 1).Tile
 CASE 4, 7, 12
  SELECT CASE Map(Col - 1, Row).Tile
   CASE 6, 10, 14
    Map(Col - 1, Row - 1).Tile = 8
  END SELECT
END SELECT

SELECT CASE Map(Col + 2, Row + 1).Tile
 CASE 3, 10, 13
  SELECT CASE Map(Col + 1, Row).Tile
   CASE 5, 7, 12
    Map(Col + 1, Row + 1).Tile = 9
  END SELECT
END SELECT

SELECT CASE Map(Col - 2, Row + 1).Tile
 CASE 3, 9, 14
  SELECT CASE Map(Col - 1, Row).Tile
   CASE 6, 8, 12
    Map(Col - 1, Row + 1).Tile = 10
  END SELECT
END SELECT


END SUB

